<template>
  <div>
    <section class="tile">
      <label id="label_players"
             for="input_players">
        Players
      </label>
      <input
          id="input_players"
          aria-label="input_players"
          type="number"
          :disabled="isShuffling"
          placeholder="8"
          @input="handleInput"/>
      <button :disabled="inactivePlayers.length === 0 || isShuffling"
              @click="handleShufflePlace">Shuffle place
      </button>
    </section>

    <div>
      <section class="tile">
        <h3>Drag & drop players from here</h3>
        <Container
            class="flex-container"
            v-if="inactivePlayers.length >0"
            :get-child-payload="getChildPayloadInactive"
            :should-accept-drop="() => false">
          <Draggable v-for="item in inactivePlayers" :key="`inactive_${item.id}`">
            <Tile
                :item="item"
                :allows-drop="false"
                :on-drop="(result)=>onDropBrackets(result, item.id, true)"
            />
          </Draggable>
        </Container>
        <h4 v-if="inactivePlayers.length === 0">All players have been placed</h4>
      </section>

      <div class="tile flex-container">
        <Container class="column-main" :get-child-payload="getChildPayloadActive"
                   :should-accept-drop="() => false">
          <Draggable v-for="(item) in this.activePlayers"
                     :key="`active_${(item && item.id) || randomId()}`">
            <Tile
                :item="item"
                :allows-drop="allowsDrop(item)"
                :allows-drag="allowsDrag(item)"
                :on-drop="(result)=>onDropBrackets(result, item.id)"
            />
          </Draggable>
        </Container>
        <div v-for="(col, index) in followUp" :key="col.id" class="column">
          <div class="column-container">
            <div v-for="item in col.items" :key="`future_${randomId()}`">
              <Binder :index="index"/>
              <Tile :item="item"
                    :allows-drag="false"
                    :allows-drop="false"/>
            </div>
          </div>
        </div>
      </div>
    </div>
    <section class="tile">
      <h3>"Binary" Tree</h3>
      <textarea>{{JSON.stringify(this.tree,null,2)}}</textarea>
    </section>

    <section class="tile">
      <h3>Project description</h3>
      <p>Implement random player-names list and unique random ID's (do some random list
        generator).</p>
      <p>Implement following features:</p>
      <p>- automatic players placement to 1st round</p>
      <p> - manual drag & drop to 1st round only! (prop which allows "drop" on match you need to
        implement as component prop, e.g. "allowDrop")</p>
    </section>

    <footer>The very first Vue project by Andrey Paramonov</footer>
  </div>
</template>

<script>
  import {Container, Draggable} from "vue-smooth-dnd";
  import {uuid} from 'vue-uuid';
  import Tile from './components/Tile.vue'
  import Binder from './components/Binder.vue';
  import {generateBrackets} from './brackets-generator.js';
  import {leaves} from './binary-tree.js'

  const FREE_SLOT = 'Free slot';
  const generatePlayers = (count, namingFunction) => {
    const items = [];
    for (let i = 0; i < count; i++) {
      const id = uuid.v4();
      items.push({id, data: namingFunction(id, i)});
    }
    return items;
  };

  const followUpBrackets = (count) => {
    const columns = [];
    const iterations = Math.ceil(Math.log2(count));
    let players = count;
    for (let col = 0; col < iterations; col += 1) {
      players = Math.ceil(players / 2);
      const row = generatePlayers(players, () => (""));
      columns.push({id: uuid.v4(), items: row});
    }
    return columns;
  };

  const fillFreeSlots = (count, activePlayers) => {
    let players = count;
    let freeSlots = 0;
    while (Math.log2(players) % 1 !== 0) {
      activePlayers.splice(freeSlots * 2 + 1, 1, {id: null, data: FREE_SLOT});
      players += 1;
      freeSlots += 1;
    }
  };

  export default {
    name: "App",
    components: {Binder, Container, Draggable, Tile},
    data() {
      return {
        count: 8,
        activePlayers: [],
        inactivePlayers: [],
        followUp: [],
        isShuffling: false,
        tree: {
          name: 'Final',
          children: []
        }
      };
    },
    created() {
      this.initPlayers(this.count);
    },
    computed: {},
    methods: {
      randomId() {
        return uuid.v4();
      },
      nextLog(count) {
        while (Math.log2(count) % 1 !== 0) {
          count += 1;
        }
        return count;
      },
      initPlayers(count) {
        const players = this.nextLog(count);

        this.inactivePlayers = generatePlayers(count, i => ("Player"));
        this.tree = generateBrackets(players);
        this.activePlayers = leaves(this.tree).map(l => l.player);

        fillFreeSlots(count, this.activePlayers);

        this.followUp = followUpBrackets(players);
        this.count = players;
      },

      onDropBrackets(dropResult, itemId) {
        if (dropResult.payload !== null && dropResult.payload !== undefined && dropResult.addedIndex
            !== null) {
          const {container, index} = dropResult.payload;
          const drop = container === 'inactive';

          if (!drop) {
            const fromIndex = this.activePlayers.map(player => player.id).indexOf(
                dropResult.payload.id);
            const toIndex = this.activePlayers.map(player => player.id).indexOf(itemId);
            const [removed] = this.activePlayers.splice(fromIndex, 1,
                {id: `empty_${fromIndex}`, data: ''});
            this.activePlayers.splice(toIndex, 1, removed);

            const l = leaves(this.tree);
            l[toIndex].player = l[fromIndex].player;
            l[fromIndex].player = {id: `empty_${fromIndex}`, data: ''};

          } else {
            const dropIndex = this.activePlayers.map(player => player.id).indexOf(itemId);
            const [removed] = this.inactivePlayers.splice(index, 1);
            this.activePlayers[dropIndex] = removed;

            const l = leaves(this.tree);
            l[dropIndex].player = removed;
          }
        }
      },

      getChildPayloadInactive(index) {
        return {
          container: 'inactive',
          index,
          id: this.inactivePlayers[index].id
        };
      },
      getChildPayloadActive(index) {
        return {
          container: 'active',
          index,
          id: this.activePlayers[index].id
        };
      },
      allowsDrop(item) {
        return !item.data && item.data !== FREE_SLOT;
      },
      allowsDrag(item) {
        return !!item.data && item.data !== FREE_SLOT;
      },
      handleInput(input) {
        const count = +input.target.value;
        if (count <= 0) {
          return;
        }
        this.initPlayers(count);
      },
      handleShufflePlace() {
        const order = this.inactivePlayers
        .map(p => ({id: p.id, order: Math.random()}))
        .sort((a, b) => (a.order - b.order))
        .map(p => (p.id));

        const findIndex = (dropIndex) => {
          while (this.activePlayers[dropIndex].data) {
            if (dropIndex >= this.count - 1) {
              dropIndex = -1;
            }
            dropIndex++;
          }
          return dropIndex;
        };
        this.isShuffling = true;
        this.inactivePlayers.forEach((player, index) => {
          setTimeout(() => {
            const dropIndex = findIndex(order.indexOf(player.id));
            const [removed] = this.inactivePlayers.splice(0, 1);
            this.activePlayers[dropIndex] = removed;
            if (this.inactivePlayers.length <= 1) {
              this.isShuffling = false;
            }
            const l = leaves(this.tree);
            l[dropIndex].player = removed;
          }, index * 70);
        });
      }
    }

  };
</script>

<style scoped>
  * {
    font-family: monospace, sans-serif;
  }

  input {
    min-width: 220px;
  }

  input, button {
    margin-left: 1em;
  }

  textarea {
    width: 100%;
    height: 400px;
    font-size: 5pt;
  }

  svg {
    height: 58px;
    margin-left: -0.5em;
    position: absolute;
  }

  .flex-container {
    display: flex;
  }

  .tile {
    padding: 1em 2em;
  }

  .column-main {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .column {
    display: flex;
    align-items: center;
  }

  .column-container {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: space-around;
    align-content: space-between;
    height: fill-available;
  }

</style>
